// подключение файла с константами
#include "defines.h"
// подключение библиотеки для шагового двигателя
#include<AccelStepper.h>
// создаем экземпляр AccelStepper 
AccelStepper motor(8, motorIN1, motorIN3, motorIN2, motorIN4);
// подключение библиотеки памяти EEPROM
#include<EEPROM.h>

// ****** переменные 
int resSettings=0;      // режим настройки

struct PLATFORM {
   int dir;               // направление движения мотора (-1, 0, 1) 
   int speedMotor;        // скорость движения мотора
   int numLight;          // номер режима освещения      
                          // 0 - выкл, 
                          // 1 - пост. цвет и яркость,
                          // 2 - пост. цвет и меняющаяся яркость,   
                          // 3 - все цвета и постоянная яркость,
                          // 4 - все цвета и меняющаяся яркость,
   int color;             // цвет
   int bright;            // яркость
   //unsigned long pause;   // скорость изменения яркости
   unsigned int pause;   // скорость изменения яркости
   int currentColor;      // текущий цвет
   int currentBright;     // текущая яркость
   int dirCurrentBright;  // текущее направление изменения яркости
};

PLATFORM platform={-1,200,4,2,200,1000,2,10,1};
unsigned long millisChangeRGB=0;
unsigned long millisSetPause=0;

String inputString = "";         // строка накопления данных из HC05
boolean stringComplete = false;  // строка полная (пришел символ '$')
// буфер получения данных из bluetooth
int inHC05data[4];

void setup()
{
  // запуск последовательного порта для отладки
  Serial.begin(9600);
  inputString.reserve(30);
  // установка светодиодов начальная
  pinMode(pinLedSettingsRed,OUTPUT);
  pinMode(pinLedSettingsGreen,OUTPUT);
  pinMode(pinLedSettingsBlue,OUTPUT);
  //digitalWrite(pinLedSettingsRed,LOW);
  //digitalWrite(pinLedSettingsGreen,LOW);
  //digitalWrite(pinLedSettingsBlue,LOW);

  pinMode(pinLedLightRed,OUTPUT);
  pinMode(pinLedLightGreen,OUTPUT);
  pinMode(pinLedLightBlue,OUTPUT);
  //digitalWrite(pinLedLightRed,LOW);
  //digitalWrite(pinLedLightGreen,LOW);
  //digitalWrite(pinLedLightBlue,LOW);  
  
  // установка пина зуммера
  pinMode(pinBuzzer,OUTPUT);

  // начальные настройки
  //iniEEPROM();
  getParamsEEPROM();

  /*Serial.print("platform.dir=");Serial.println(platform.dir);
  Serial.print("platform.speedMotor=");Serial.println(platform.speedMotor);
  Serial.print("platform.numLight=");Serial.println(platform.numLight);
  Serial.print("platform.color=");Serial.println(platform.color);
  Serial.print("platform.bright=");Serial.println(platform.bright);
  Serial.print("platform.currentColor=");Serial.println(platform.currentColor);
  Serial.print("platform.dirCurrentBright=");Serial.println(platform.dirCurrentBright);
  Serial.print("platform.pause=");Serial.println(platform.pause);
  */
  // ****** тест
  test();

  // шаговый двигатель запустить
  tone(pinBuzzer,350,1500);
  motor.setMaxSpeed(1000);
  setSpeedMotor(platform.speedMotor, platform.dir);
  //Serial.println("start"); 
}


void loop() {
   // данные по bluetooth
   if (stringComplete) {
    //Serial.println(inputString);
    if(parseHC05()) {
       //Serial.println("ok");
       setParam(inHC05data[0],inHC05data[1]);
    }
    else {
       //Serial.println("no");
    }

    // 
    inputString = "";
    stringComplete = false;
  }
   // проверка нажатия-отжатия кнопки
   int but=getButton();
   if(but>0) {
      //Serial.println(but); 
      switch(resSettings) {
         case 0:
              doButtons0(but);
            break;
         case 1:
              doButtons1(but);
            break;
         case 2:
              doButtons2(but);
            break;
         case 3:
              doButtons3(but);
            break;
         case 4:
              doButtons4(but);
            break;
         case 5:
              doButtons5(but);
            break;
         case 6:
              doButtons6(but);
            break;
         case 7:
              doButtons7(but);
            break;
         default:
            break;
      }
   }
   motor.runSpeed();
   // освещение RGB-лента
   RGB(platform.numLight);
}


